/*
 * GccApplication1.c
 *
 * Created: 5/19/2018 5:25:45 PM
 * Author : andre
 */ 

#include <avr/io.h>


#include "lcd.h"
#include "usart.h"
#include "DHT.h"

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50
#define DHT11_PIN 6
uint8_t c=0,I_RH,D_RH,I_Temp,D_Temp,CheckSum;
int fadeRate = 0;
volatile int BPM;
volatile int bmp;
volatile int Signal;
volatile int IBI = 600;
volatile bool Pulse = false;
volatile bool QS = false;
volatile int rate[10];
volatile unsigned long sampleCounter = 0;
volatile unsigned long lastBeatTime = 0;
volatile int P =512;
volatile int T = 512;
volatile int thresh = 512;
volatile int amp = 100;
volatile bool firstBeat = true;
volatile bool secondBeat = false;
int apasat = 1;
char clear[16] = "                ";
int8_t first_line = 0;
int8_t second_line = 64;
int8_t temperature = 0;
char temp_msg[30];

//Get temperature from DHT11 sensor;
void task_sensorDHT11()
{
	_delay_ms(100);
	dht_gettemperature(&temperature);
	_delay_ms(100);
	memset(temp_msg, 0, sizeof(temp_msg));
	sprintf(temp_msg, "Temperature: %d C", (int)temperature);
	LCD_printAt(0, clear);
	LCD_printAt(64, temp_msg);

}

void exemplu_lcd()
{
	LCD_print("Hello World PM!");

	for(;;);
}

void LED_init()
{
	DDRB |= (1 << PB4);
	PORTB &= ~(1 << PB4);
}

void BTN_init()
{
	DDRB &= ~(1 << PB0);
	PORTB |= (1 << PB0);

}

void LED_stinge()
{
	PORTB &= ~(1 << PB4);
}

void LED_aprinde()
{
	PORTB |= (1 << PB4);
}

void task_LED()
{
	uint8_t apasat = 0;
	uint8_t flag = 0;
	while(1) {
		if ((PINB & (1 << PB0)) == 0) {
			if (!apasat && (flag == 0)) {
				LED_aprinde();
				apasat = 1;
				flag = 1;
			} else {
				apasat = 0;
			}

			if (!apasat && (flag == 1)) {
				LED_stinge();
				apasat = 1;
				flag = 0;
			} else {
				apasat = 0;
			}
		}
		//_delay_ms(5);
	}
}

void speaker_init()
{

	DDRD |= (1 << PD5);
	PORTD &= ~(1 << PD5);
}

/* Genereaza sunetul pentru tipul de ton folosit: lung (150ms) sau scurt (50ms). */
void speaker_morse(int tip_morse) {
	int i;

	/* Alternam starea pinului PD4 la fiecare milisecunda. */
	for (i = 0; i < tip_morse; ++i) {
		PIND = (1 << PD5);

		_delay_ms(1);
	}
}

void speaker_close()
{
	PORTD &= ~(1 << PD5);
}

void task_speaker()
{
	uint8_t apasat = 0;
	uint8_t flag = 0;
	while (1) {
		if ((PINB & (1 << PB0)) == 0) {
			if (!apasat && (flag == 0)) {
				speaker_morse(MORSE_LUNG);
				apasat = 1;
				flag = 1;
			} else {
				apasat = 0;
			}

			if (!apasat && (flag == 1)) {
				PORTD &= ~(1 << PD5);
				apasat = 1;
				flag = 0;
			} else {
				apasat = 0;
			}
		}
		_delay_ms(MORSE_PAUZA);
	}
}

#define ADC_AREF_VOLTAGE 3.3
#define ADC_MAX_CHANNELS 6
#define ADC_INIT_CHANNEL 0
#define ADC_USE_IRQ

typedef struct
{
	const char *name;
	uint8_t    channel;
} adc_channel_t;

const adc_channel_t ADC_channels[] = {
	// Senzor de puls conenctat la ADC0
	{"Pulse", 0}
};

const int adc_num_channels = sizeof(ADC_channels) / sizeof(ADC_channels[0]);
volatile uint16_t ADC_value[ADC_MAX_CHANNELS];

#ifdef ADC_USE_IRQ
ISR(ADC_vect)
{
	// Intreruperea este triggered cand o conversie este finalizata.
	static uint8_t channel = ADC_INIT_CHANNEL;

	ADC_value[channel] = ADC;

	ADMUX = (ADMUX & ~(0x1f << MUX0));

	ADCSRA |= (1 << ADSC);
}

ISR(TIMER1_COMPA_vect)
{
	// start an ADC conversion
	ADCSRA |= (1 << ADSC);
	sampleCounter+=2;
	int N = sampleCounter - lastBeatTime;
	Signal = ADC;
	if(Signal < thresh && N > (IBI/5)*3){
		if (Signal < T){
			T = Signal;
		}
	}

	if(Signal > thresh && Signal > P){
		P = Signal;
	}

	if (N > 250){
		if ( (Signal > thresh) && (Pulse == false) && (N > ((IBI/5)*3) )){
			Pulse = true;
			if (apasat == 1) {
				LED_aprinde();
				speaker_morse(MORSE_LUNG);
			}

			IBI = sampleCounter - lastBeatTime;
			lastBeatTime = sampleCounter;

			if(secondBeat){
				secondBeat = false;
				for(int i=0; i<=9; i++){
					rate[i] = IBI;
				}
			}

			if(firstBeat){
				firstBeat = false;
				secondBeat = true;
				sei();
				return;
			}

			double runningTotal = 0;
			for(int i=0; i<=8; i++){
				rate[i] = rate[i+1];
				runningTotal += rate[i];
			}
			rate[9] = IBI;
			runningTotal += rate[9];
			runningTotal /= 10;
			BPM = 60000/runningTotal;
			QS = true;
		}
	}

	if (Signal < thresh && Pulse == true){
		if(apasat == 1) {
			LED_stinge();
			speaker_close();
		}
		Pulse = false;
		amp = P - T;
		thresh = amp/2 + T;
		P = thresh;
		T = thresh;
	}

	if (N > 2500){
		thresh = 512;
		P = 512;
		T = 512;
		firstBeat = true;
		secondBeat = false;
		lastBeatTime = sampleCounter;
	}
}
#endif

void ADC_init(void)
{
	#ifndef ADC_USE_IRQ
	ADMUX = (1 << REFS0);
	ADCSRA = (1 << ADEN) | (5 << ADPS0);
	#else
	ADMUX = (1 << REFS0) | (1 << ADC_INIT_CHANNEL);
	ADCSRA = (1 << ADEN) | (1 << ADIE) | (5 << ADPS0);
	#endif
}

uint16_t ADC_get(uint8_t channel)
{
	#ifndef ADC_USE_IRQ
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;
	ADCSRA |= (1 << ADSC);
	while(ADCSRA & (1 << ADSC));
	return ADC;
	#else
	return ADC_value[channel];
	#endif
}

double ADC_voltage(int raw)
{
	(void)raw;
	return raw * ADC_AREF_VOLTAGE / 1023.0;
}

void ADC_show(void)
{
	char buf[32];
	char buf2[32];
	const adc_channel_t *channel = &ADC_channels[0];

	int signal = ADC_voltage(ADC_get(0));
	sprintf(buf, "%s:%d", channel->name,
	signal);
	sprintf(buf2, "%s:%d", "BPM", BPM);
	int ADC_signal = ADC_get(0);
	char buf_adc[4];
	sprintf(buf_adc, "%d", ADC_signal);
	buf_adc[4] = '\0';
	USART0_print(buf_adc);
	USART0_transmit('\n');
	LCD_printAt(0, clear);
	LCD_printAt(0, buf);
	LCD_printAt(8, buf2);
	LCD_printAt(64, clear);
	
}

#ifdef ADC_USE_IRQ
void TIMER1_init()
{
	// initialize timer to trigger COMPA every 100ms
	/*TCCR1B = (5 << CS10) | (1 << WGM12);
	TIMSK1 |= (1 << OCIE1A);
	OCR1A = 1561;*/
	TCCR1A = 0x00;
	TCCR1B = 0x0C;
	OCR1A = 0x7C;
	TIMSK1 = 0x02;
	//OCR1A = 124;
	// prescaler 256;
}
#endif

ISR(PCINT1_vect)
{
	if ((PINB & (1 << PB0)) == 0)
	{
		apasat *= -1;
	}
}

void Intr_init()
{
	// Activez intreruperea pe butonul PB0
	PCICR |= (1 << PCIE1);
	PCMSK1 |= (1 << PCINT8);

}

int main()
{
	LCD_init();
	DDRC |= (1 << PC2);
	PORTC |= (1 << PC2);

	BTN_init();

	Intr_init();

	LED_init();

	speaker_init();

	USART0_init();

	ADC_init();

	#ifdef ADC_USE_IRQ
	TIMER1_init();
	#endif

	// Enable interrupts.
	sei();

	for(;;) {
		if (apasat == 1) {
			ADC_show();
		} else {
			task_sensorDHT11();
		}
		_delay_ms(10);
	}
	
	return 0;
}

